//	UpDnCounter.v

module UpDnCounter
	(
		input wire			Up, Dn, Enable, Clock, Reset,

		output wire			S1, S0, Z
	);

	reg [1:0]				state;

	assign	Z = state == 2'b00;
	assign	{S1,S0} = state;
	
	always @ (posedge Clock, posedge Reset)
	begin
		if (Reset) state = 2'b00;
		else if (Enable)
		begin
			if (Up) state = state + 1;
			if (Dn) state = state - 1;
		end
    end

endmodule